CREATE DATABASE 'C:\Programme\Firebird\Firebird_3_0\ARTIKEL.fdb';
CONNECT 'c:\Programme\Firebird\Firebird_3_0\ARTIKEL.fdb' user 'SYSDBA' password 'masterkey';
CREATE TABLE mwst(mwst_art CHARACTER(9) DEFAULT 'kein' NOT NULL PRIMARY KEY, mwst_satz SMALLINT DEFAULT 0 NOT NULL);
CREATE TABLE kunden (mid int NOT NULL,kid varchar(50) NOT NULL,firma varchar(59),anrede varchar (10),nachname varchar(50) NOT NULL,vorname varchar(30),rechnungsadresse varchar(255) DEFAULT 'wie Anschrift' NOT NULL ,strasse varchar(50),PLZ char(5),ort varchar(50) DEFAULT 'Celle' NOT NULL ,land varchar (50) DEFAULT 'Deutschland',geworbenvon int,geburtsdatum date,letzte_aenderung timestamp DEFAULT current_timestamp,CONSTRAINT PKKD PRIMARY KEY (mid,kid));
CREATE TABLE warengruppe(kennziffer INT NOT NULL PRIMARY KEY,warengruppe VARCHAR(255) DEFAULT 'unbekannt' NOT NULL);
CREATE TABLE artikel (anr int NOT NULL PRIMARY KEY,bezeichnung VARCHAR(255) NOT NULL,gebinde FLOAT,einheit VARCHAR(30),wgknz INT DEFAULT 0 NOT NULL REFERENCES warengruppe(kennziffer) ON DELETE CASCADE ON UPDATE CASCADE,einstandspreis DECIMAL(6,2) CHECK (einstandspreis >= 0),listenpreis DECIMAL(6,2) CHECK(listenpreis >= 0),mwst_art CHAR(9) DEFAULT 'voll' NOT NULL REFERENCES mwst(mwst_art) ON DELETE SET DEFAULT ON UPDATE CASCADE,mindestbestand INT DEFAULT 0 NOT NULL CHECK (mindestbestand >= 0),letzte_aenderung timestamp DEFAULT current_timestamp,CHECK (listenpreis >= einstandspreis * 1.5));
CREATE TABLE bestellung (mid INT NOT NULL,bnr INT NOT NULL,kid VARCHAR(50) NOT NULL,bestelldatum DATE NOT NULL,letzte_aenderung TIMESTAMP DEFAULT current_timestamp,CONSTRAINT PKBEST PRIMARY KEY (mid,bnr),CONSTRAINT FKBESTKUND FOREIGN KEY (mid,kid) REFERENCES kunden(mid,kid)ON UPDATE CASCADE ON DELETE SET NULL,UNIQUE (kid,bestelldatum));
CREATE TABLE bestell_position (mid INT NOT NULL,bnr INT NOT NULL,pos INT NOT NULL,anr INT NOT NULL,anzahl INT DEFAULT 1 NOT NULL,letzte_aenderung TIMESTAMP DEFAULT current_timestamp,CONSTRAINT PKBESTPOS PRIMARY KEY (mid,bnr,pos),CONSTRAINT FKBESTPOSBEST FOREIGN KEY (mid,bnr) REFERENCES bestellung (mid,bnr) ON UPDATE CASCADE ON DELETE CASCADE,CHECK (anzahl >=0));
exit